package com.gx.obe.util.utils;

import org.eclipse.swt.dnd.Clipboard;
import org.eclipse.swt.dnd.TextTransfer;
import org.eclipse.swt.dnd.Transfer;
import org.eclipse.swt.widgets.Display;

/**
 * @Description: 
 * @author guoyr
 */
public class ClipboardUtils {

	/**
	 * @Description: 复制
	 * @author guoyr
	 * @param string
	 */
	public static void copy(String string){
		Clipboard clipboard =new Clipboard(Display.getDefault());
		clipboard.setContents(new String[]{string},new Transfer[]{TextTransfer.getInstance()}); //复制内容
		clipboard.dispose();
	}
	
	/**
	 * @Description: 粘贴
	 * @author guoyr
	 * @return
	 */
	public static String paste(){
		Clipboard clipboard =new Clipboard(Display.getDefault()); 
		String result =(String) clipboard.getContents(TextTransfer.getInstance()); //获取粘贴
		clipboard.dispose();
		return (null != result?result:"");
	}
}
