package com.gx.obe.util.utils;

import java.util.function.Function;
import java.util.function.Predicate;

public class PredicateUtil {
	
	public static <T, R> Predicate<T> get(Function<T, R> function, Predicate<R> predicate) {
		return t -> predicate.test(function.apply(t));
	}
	
}
