package com.gx.obe.util.utils;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;

import org.apache.log4j.Logger;

public class RuntimeUtils {

	public static Logger LOG = Logger.getLogger(RuntimeUtils.class);
	/**
	 * @Description: 打开目录
	 * @author guoyr
	 * @param director
	 */
	public static void openDirector(String director){
		
		try {
			Runtime.getRuntime().exec("explorer.exe " + director.replace("\\\\", "\\"));
		} catch (IOException e) {
			LOG.error("", e);
		}
	}
	
	/**
	 * @Description: 打开并选中目录
	 * @author guoyr
	 * @param director
	 */
	public static void openDirectorAndSelect(String director){
		
		try {
			Runtime.getRuntime().exec("explorer.exe /select," + director.replace("\\\\", "\\"));
		} catch (IOException e) {
			LOG.error("", e);
		}
	}
	
	/**
	 * @Description: 打开流览器
	 * @author guoyr
	 * @param url
	 */
	public static void openBrowser(String url){
		try {
			Runtime.getRuntime().exec("cmd /c start " + url);
		} catch (IOException e) {
			LOG.error("", e);
		}
	}
	
	/**
	 * @Description: 打开文件
	 * @author guoyr
	 * @param file 
	 */
	public static void openFIle(File file, String openExe){
		try {
			Runtime.getRuntime().exec("\""+openExe + "\" " + "\""+file.getAbsolutePath()+"\"");
		} catch (IOException e) {
			LOG.error("", e); 
			openFIle(file);
		}
	}
	/**
	 * @Description: 打开文件
	 * @author guoyr
	 * @param file 
	 */
	public static void openFIle(File file){
		
		try {
			java.awt.Desktop.getDesktop().open(file); //调用open（File f）方法打开文件 
		}catch(Exception ex){
			try {
				String cmd="rundll32 url.dll FileProtocolHandler file://" + file.getAbsolutePath();//要打开的文件的路径
//				String cmd="rundll32 shell32.dll ShellExec_RunDLL " + file.getAbsolutePath();//要打开的文件的路径
				Runtime.getRuntime().exec(cmd);//创建一个子进程来执行以上命令，打开文件
			} catch (Exception e1) {
				LOG.error("", e1); 
				openDirectorAndSelect(file.getAbsolutePath());
			}
		}
	}
	
//	public static void exec(String fileName) {
//		String url = "cmd /c start " + fileName;
//		try {
//			Runtime.getRuntime().exec(url); 
//		} catch (Exception e1) {
//			LOG.error("", e1); 
//		}
//	}
	
	public static boolean execProtocol(String url) {
		boolean execFlag = false;
		try {
			Runtime rt = Runtime.getRuntime(); 
			String cmd="rundll32 url.dll FileProtocolHandler "; 
			Process pr = rt.exec(cmd + url); 
			BufferedReader input = new BufferedReader(new InputStreamReader(pr.getInputStream(), "GBK")); 
			String line = null; 
			while ((line = input.readLine()) != null) { 
				LOG.info("脚本文件执行信息:" + line);
			} 
			 // 等待程序执行结束并输出状态
		     int exitCode = pr.waitFor();
		     if (0 == exitCode) {
		    	 execFlag = true;
		     } else {
		    	 execFlag = false;
		     }
		} catch (Exception  e) {
			LOG.error("", e); 
		}
		return execFlag;
	}
	
	public static boolean execFile(String fileName) {
		return execCommand("cmd /c "+fileName, true); // cmd /c calc 
	}
	
	public static boolean execCommand(String command, boolean syn) {
		boolean execFlag = false;
		BufferedReader input = null;
		try {
			Runtime rt = Runtime.getRuntime(); 
			
			Process pr = rt.exec(command); 
			if(syn) {
				input = new BufferedReader(new InputStreamReader(pr.getInputStream(), "GBK")); 
				String line = null; 
				while ((line = input.readLine()) != null) { 
					LOG.info("脚本文件执行信息:" + line); 
				} 
				// 等待程序执行结束并输出状态
				int exitCode = pr.waitFor();
				if (0 == exitCode) {
					execFlag = true;
				} else {
					execFlag = false;
				}
			}else {
				pr.getErrorStream();
				execFlag = true;
			}
		} catch (Exception  e) {
			LOG.error("", e);
			execFlag = false;
		}finally {
			if(null != input) {
				try {
					input.close();
					input = null;
				} catch (IOException e) {
				}
			}
		}
		return execFlag;
	}
	
	public static void main(String[] arges){
		System.out.println(System.getProperty("user.home"));
		System.out.println(System.getProperty("user.dir"));
		System.out.println(System.getenv("ComSpec"));
		System.out.println(System.getProperty("java.io.tmpdir"));//显示当前系统的临时目录
	}
}
