package com.gx.obe.util.utils;

import java.io.UnsupportedEncodingException;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;

import javax.crypto.Mac;
import javax.crypto.spec.SecretKeySpec;

/**
 * @author wangx
 *
 */
public class AuthTokenUtil {

	public static String createToken(String AppKey, String AppSecret,int count, String str){
		String Token = null;
		int p1 =(int) (System.currentTimeMillis()/1000);
//		String p1Url = URLEncoder.encode(p1+"", "utf-8");
		String p2 = StringUtil.encodeString(p1+"");
		SecretKeySpec signingKey;
		String p3Str = "";
		try {
			signingKey = new SecretKeySpec(AppSecret.getBytes("UTF-8"), "HmacSHA1");
			Mac mac = Mac.getInstance("HmacSHA1");
			mac.init(signingKey);
			byte[] p3= mac.doFinal(p2.getBytes("UTF-8"));
			p3Str = new String(p3);
		} catch (UnsupportedEncodingException e) {
		} catch (NoSuchAlgorithmException e) {
		} catch (InvalidKeyException e) {
		}

		String p4 = StringUtil.encodeString(p3Str).replace("+", "-").replace("/", "_");
		
		Token=AppKey+"@"+p4+"@"+p2;
		
		return Token;
	}
	
	
	
	public static void main(String[] args) {
//		System.out.println(createToken());
	}
}
