package com.gx.obe.util.utils;

import java.util.Arrays;
import java.util.Map;
import java.util.function.Function;
import java.util.stream.Collectors;

/**
 * @Description: 枚举工具类
 * @author chenxw
 */
public class EnumUtils {
	
	/**
	 * @Description: 枚举转换为map
	 * @author chenxw
	 * @param getKey
	 * @param iEnums
	 * @return
	 */
	public static <K, V> Map<K, V> toMap(V[] enums, Function<V, K> getKey) {
		return Arrays.stream(enums).collect(Collectors.toMap(getKey, Function.identity()));
	}
	
}
