package com.gx.obe.util.utils;

import java.io.File;
import java.io.IOException;
import java.io.StringWriter;
import java.util.Locale;
import java.util.Map;

import freemarker.template.Configuration;
import freemarker.template.DefaultObjectWrapper;
import freemarker.template.Template;
import freemarker.template.TemplateException;

public class FreemarkerUtils {

	/** 
	 * @Description: 获得模板的内容
	 * @author guoyr
	 * @param   
	 * @return  
	 * @Exception   
	 */
	public static String rendFreemarker(String ftlPath, String templatePath, Map<String, Object> map) throws IOException, TemplateException {
		StringWriter result = new StringWriter();
		Configuration cfg = new Configuration();
		cfg.setDirectoryForTemplateLoading(new File(ftlPath.replace("/", File.separator)));
		cfg.setEncoding(Locale.getDefault(), "UTF-8");
		cfg.setObjectWrapper(new DefaultObjectWrapper());
		Template template = cfg.getTemplate(templatePath);
		template.setEncoding("UTF-8");
		template.process(map, result);
		return result.toString();
	}
}
