package com.gx.obe.util.utils;

/** 
 * @Description: 日志工具类
 * @author guoyr 
 */
public class LogUtils {
	
	public static org.apache.log4j.Logger logger = org.apache.log4j.Logger.getLogger(LogUtils.class);
	
	public static org.apache.log4j.Logger getLogger(Class<?> clazz){
		return org.apache.log4j.Logger.getLogger(clazz);
	}
	public static void logError(String message, Throwable e){
		logger.error(message, e);
	}
	public static void logError(String message){
		logger.error(message);
	}
	public static void logError(Throwable e){
		logger.error(null, e);
	}
	public static void logDebug(String message, Throwable e){
		logger.debug(message, e);
	}
	public static void logDebug(String message){
		logger.debug(message);
	}
	public static void logDebug(Throwable e){
		logger.debug(null, e);
	}
	public static void logWarn(String message, Throwable e){
		logger.warn(message, e);
	}
	public static void logWarn(String message){
		logger.warn(message);
	}
	public static void logWarn(Throwable e){
		logger.warn(null, e);
	}
	public static void logClass(Object obj){
		logger.debug("当前类为："+obj);
	}
	public static void logDebug(Object obj){
		logger.debug(obj);
	}
	 
}
