package com.gx.obe.util.utils;

import java.lang.annotation.Documented;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

/**
 * @Description: 
 * @author guoyr
 */
@Retention(RetentionPolicy.RUNTIME)
@Documented
public @interface XmlAnnotation {
	
	/**
	 * @Description: xml注解元素
	 * @author guoyr
	 * @return
	 */
	public String element();
	
	/**
	 * @Description: xml节点的默认值
	 * @author guoyr
	 * @return
	 */
	public String defaultValue() default "";
	
	/**
	 * @Description: 非空验证
	 * @author guoyr
	 * @return
	 */
	public boolean notNull() default false; 
}
